package MT::Plugin::EscapeCode;
use strict;
use MT;
use MT::Plugin;
use MT::Util qw( encode_html );

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::EscapeCode::ISA = qw( MT::Plugin );

my $plugin = __PACKAGE__->new( {
    id   => 'EscapeCode',
    key  => 'escapecode',
    name => 'EscapeCode',
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
    version => $VERSION,
    description => 'modifier escapecode',
} );

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;
    $plugin->registry( {
        tags => {
            modifier => {
                'escapecode' => \&_fltr_escapecode,
            },
        },
    } );
}

sub _fltr_escapecode {
    my ( $text, $arg, $ctx ) = @_;
    $arg = 'code' unless $arg;
    my $class;
    if ( $arg =~ m!,! ) {
        my @item = split( /,/, $arg );
        $arg   =  $item[0];
        $class = $item[1];
        $text =~ s!(<$arg.*?class=['"]$class['"].*?>)(.*?)(</$arg>)!$1.encode_html($2).$3!esig;
    } else {
        $text =~ s!(<$arg.*?>)(.*?)(</$arg>)!$1.encode_html($2).$3!esig;
    }
    return $text;
}

1;